using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace CheeseBreakout
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class CheeseBreakoutGame : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        Texture2D cheeseTexture;
        Texture2D breadTexture;

        int cheeseX;
        int cheeseY;
        int cheeseXSpeed = 1;
        int cheeseYSpeed = 1;

        int breadX;
        int breadY;

        public CheeseBreakoutGame()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            cheeseTexture = Content.Load<Texture2D>("cheese");
            breadTexture = Content.Load<Texture2D>("bread");
        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            // Allows the game to exit
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            cheeseX = cheeseX + cheeseXSpeed;

            if ((cheeseX <= 0) ||
                (cheeseX + cheeseTexture.Width > Window.ClientBounds.Width))
            {
                cheeseXSpeed *= -1;
            }

            cheeseY= cheeseY + cheeseYSpeed;

            if ((cheeseY <= 0) ||
                (cheeseY + cheeseTexture.Height > Window.ClientBounds.Height))
            {
                cheeseYSpeed *= -1;
            }

            GamePadState padState = GamePad.GetState(PlayerIndex.One);

            if (padState.IsConnected)
            {
                if (padState.DPad.Left == ButtonState.Pressed)
                {
                    breadX--;
                }
                if (padState.DPad.Right == ButtonState.Pressed)
                {
                    breadX++;
                }
                if (padState.DPad.Up == ButtonState.Pressed)
                {
                    breadY--;
                }
                if (padState.DPad.Down == ButtonState.Pressed)
                {
                    breadY++;
                }
            }

            KeyboardState keyboard = Keyboard.GetState();

            if (keyboard.IsKeyDown(Keys.Left))
            {
                breadX--;
            }
            if (keyboard.IsKeyDown(Keys.Right))
            {
                breadX++;
            }
            if (keyboard.IsKeyDown(Keys.Up))
            {
                breadY--;
            }
            if (keyboard.IsKeyDown(Keys.Down))
            {
                breadY++;
            }
            
            // Let the GameComponents update
            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();
            spriteBatch.Draw(cheeseTexture,
                new Rectangle(
                    cheeseX, cheeseY,
                    cheeseTexture.Width, cheeseTexture.Height),
                Color.White);

            spriteBatch.Draw(breadTexture,
                new Rectangle(breadX, breadY, breadTexture.Width, breadTexture.Height), Color.White);


            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}
