using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using Microsoft.Xna.Framework.Content;

namespace CheeseBreakout
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public class BackgroundComponent : Microsoft.Xna.Framework.DrawableGameComponent
    {
        public BackgroundComponent(Game game)
            : base(game)
        {
            // TODO: Construct any child components here
        }

        SpriteBatch spriteBatch;
        Texture2D backgroundTexture;
        Rectangle backgroundRectangle;

        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            spriteBatch = new SpriteBatch(Game.GraphicsDevice);
            backgroundTexture = Game.Content.Load<Texture2D>("background");
            backgroundRectangle = new Rectangle(
                0, 0, 
                Game.GraphicsDevice.Viewport.Width, Game.GraphicsDevice.Viewport.Height);
            this.DrawOrder = 0;
            base.Initialize();
        }

        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // TODO: Add your update code here

            base.Update(gameTime);
        }

        public override void Draw(GameTime gameTime)
        {
            spriteBatch.Begin();
            spriteBatch.Draw(backgroundTexture, backgroundRectangle,Color.White);
            spriteBatch.End();
            base.Draw(gameTime);
        }
    }
}