using System;
using System.Collections.Generic;
using System.Text;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;


namespace CheeseBreakout
{
    /// <summary>
    /// This is a game component that implements IUpdateable.
    /// </summary>
    public partial class StatusDisplay : Microsoft.Xna.Framework.DrawableGameComponent
    {

        IGetStatusText statusSource;


        public StatusDisplay(Game game, IGetStatusText inStatusSource)
            : base(game)
        {
            statusSource = inStatusSource;
        }


        /// <summary>
        /// Allows the game component to perform any initialization it needs to before starting
        /// to run.  This is where it can query for any required services and load content.
        /// </summary>
        public override void Initialize()
        {
            this.DrawOrder = 2;

            base.Initialize();
        }

        public override void Draw(GameTime gameTime)
        {
            string text = statusSource.GetStatus();
            SpriteFont font = statusSource.FontDraw;
            SpriteBatch spriteBatch = statusSource.SpriteBatchDraw;

            spriteBatch.Begin();
            spriteBatch.DrawString(font, text, new Vector2
                ((int)((Game.Window.ClientBounds.Width - font.MeasureString(text).X) / 2.0f), 0), Color.Blue);
            spriteBatch.End();
            base.Draw(gameTime);
        }

        /// <summary>
        /// Allows the game component to update itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        public override void Update(GameTime gameTime)
        {
            // TODO: Add your update code here

            base.Update(gameTime);
        }
    }
}
