using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace ReactionTimer
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;
        SpriteFont font;

        // Game World
        int timer;
        int[] scores = new int[16];

        string[] names = new string[] {
            "Gamepad 1 A",
            "Gamepad 1 B",
            "Gamepad 1 X",
            "Gamepad 1 Y",
            "Gamepad 2 A",
            "Gamepad 2 B",
            "Gamepad 2 X",
            "Gamepad 2 Y",
            "Gamepad 3 A",
            "Gamepad 3 B",
            "Gamepad 3 X",
            "Gamepad 3 Y",
            "Gamepad 4 A",
            "Gamepad 4 B",
            "Gamepad 4 X",
            "Gamepad 4 Y",
        };

        string winnerName = "";
        Vector2 winnerPos = new Vector2(150, 500);

        // Game world sounds
        static AudioEngine audio;
        static WaveBank waves;
        static SoundBank sounds;

        // Gamepad 1
        GamePadState pad1;
        GamePadState oldpad1;

        Vector2 apos1 = new Vector2(150, 250);
        Vector2 bpos1 = new Vector2(200, 200);
        Vector2 xpos1 = new Vector2(100, 200);
        Vector2 ypos1 = new Vector2(150, 150);

        // Gamepad 2
        GamePadState pad2;
        GamePadState oldpad2;

        Vector2 apos2 = new Vector2(650, 250);
        Vector2 bpos2 = new Vector2(700, 200);
        Vector2 xpos2 = new Vector2(600, 200);
        Vector2 ypos2 = new Vector2(650, 150);

        // Gamepad 3
        GamePadState pad3;
        GamePadState oldpad3;

        Vector2 apos3 = new Vector2(150, 450);
        Vector2 bpos3 = new Vector2(200, 400);
        Vector2 xpos3 = new Vector2(100, 400);
        Vector2 ypos3 = new Vector2(150, 350);

        // Gamepad 4
        GamePadState pad4;
        GamePadState oldpad4;

        Vector2 apos4 = new Vector2(650, 450);
        Vector2 bpos4 = new Vector2(700, 400);
        Vector2 xpos4 = new Vector2(600, 400);
        Vector2 ypos4 = new Vector2(650, 350);

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        /// <summary>
        /// Allows the game to perform any initialization it needs to before starting to run.
        /// This is where it can query for any required services and load any non-graphic
        /// related content.  Calling base.Initialize will enumerate through any components
        /// and initialize them as well.
        /// </summary>
        protected override void Initialize()
        {
            // TODO: Add your initialization logic here

            base.Initialize();
        }

        /// <summary>
        /// LoadContent will be called once per game and is the place to load
        /// all of your content.
        /// </summary>
        protected override void LoadContent()
        {
            // Create a new SpriteBatch, which can be used to draw textures.
            spriteBatch = new SpriteBatch(GraphicsDevice);

            audio = new AudioEngine("Content\\Sounds\\GameSounds.xgs");
            waves = new WaveBank(audio, "Content\\Sounds\\Wave Bank.xwb");
            sounds = new SoundBank(audio, "Content\\Sounds\\Sound Bank.xsb");

            font = Content.Load<SpriteFont>("Arial");

        }

        /// <summary>
        /// UnloadContent will be called once per game and is the place to unload
        /// all content.
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// Allows the game to run logic such as updating the world,
        /// checking for collisions, gathering input, and playing audio.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Update(GameTime gameTime)
        {
            pad1 = GamePad.GetState(PlayerIndex.One);

            if (pad1.Buttons.Back == ButtonState.Pressed)
            {
                this.Exit();
            }

            // start a new game
            if (pad1.Buttons.Start == ButtonState.Pressed)
            {
                for (int i = 0; i < 16; i++)
                {
                    scores[i] = 0;
                }
                winnerName = "";
                timer = -120;
            }

            // update the timer
            timer++;

            // play the sound at the start of the game
            if (timer == 0)
            {
                sounds.PlayCue("ding");
            }

            // if A is pressed and scores[0] is 0 copy the timer
            if (oldpad1.Buttons.A == ButtonState.Released &&
                 pad1.Buttons.A == ButtonState.Pressed && scores[0] == 0)
            {
                scores[0] = timer;
            }

            if (oldpad1.Buttons.B == ButtonState.Released &&
                 pad1.Buttons.B == ButtonState.Pressed && scores[1] == 0)
            {
                scores[1] = timer;
            }

            if (oldpad1.Buttons.X == ButtonState.Released &&
                 pad1.Buttons.X == ButtonState.Pressed && scores[2] == 0)
            {
                scores[2] = timer;
            }

            if (oldpad1.Buttons.Y == ButtonState.Released &&
                 pad1.Buttons.Y == ButtonState.Pressed && scores[3] == 0)
            {
                scores[3] = timer;
            }

            oldpad1 = pad1;

            pad2 = GamePad.GetState(PlayerIndex.Two);

            if (pad2.IsConnected)
            {

                if (oldpad2.Buttons.A == ButtonState.Released &&
                     pad2.Buttons.A == ButtonState.Pressed && scores[4] == 0)
                {
                    scores[4] = timer;
                }

                if (oldpad2.Buttons.B == ButtonState.Released &&
                     pad2.Buttons.B == ButtonState.Pressed && scores[5] == 0)
                {
                    scores[5] = timer;
                }

                if (oldpad2.Buttons.X == ButtonState.Released &&
                     pad2.Buttons.X == ButtonState.Pressed && scores[6] == 0)
                {
                    scores[6] = timer;
                }

                if (oldpad2.Buttons.Y == ButtonState.Released &&
                     pad2.Buttons.Y == ButtonState.Pressed && scores[7] == 0)
                {
                    scores[7] = timer;
                }

                oldpad2 = pad2;
            }

            pad3 = GamePad.GetState(PlayerIndex.Three);

            if (pad3.IsConnected)
            {

                if (oldpad3.Buttons.A == ButtonState.Released &&
                     pad3.Buttons.A == ButtonState.Pressed && scores[8] == 0)
                {
                    scores[8] = timer;
                }

                if (oldpad3.Buttons.B == ButtonState.Released &&
                     pad3.Buttons.B == ButtonState.Pressed && scores[9] == 0)
                {
                    scores[9] = timer;
                }

                if (oldpad3.Buttons.X == ButtonState.Released &&
                     pad3.Buttons.X == ButtonState.Pressed && scores[10] == 0)
                {
                    scores[10] = timer;
                }

                if (oldpad3.Buttons.Y == ButtonState.Released &&
                     pad3.Buttons.Y == ButtonState.Pressed && scores[11] == 0)
                {
                    scores[11] = timer;
                }

                oldpad3 = pad3;
            }

            pad4 = GamePad.GetState(PlayerIndex.Four);

            if (pad4.IsConnected)
            {

                if (oldpad4.Buttons.A == ButtonState.Released &&
                     pad4.Buttons.A == ButtonState.Pressed && scores[12] == 0)
                {
                    scores[12] = timer;
                }

                if (oldpad4.Buttons.B == ButtonState.Released &&
                     pad4.Buttons.B == ButtonState.Pressed && scores[13] == 0)
                {
                    scores[13] = timer;
                }

                if (oldpad4.Buttons.X == ButtonState.Released &&
                     pad4.Buttons.X == ButtonState.Pressed && scores[14] == 0)
                {
                    scores[14] = timer;
                }

                if (oldpad4.Buttons.Y == ButtonState.Released &&
                     pad4.Buttons.Y == ButtonState.Pressed && scores[15] == 0)
                {
                    scores[15] = timer;
                }

                oldpad4 = pad4;
            }

            if (timer == 120)
            {
                int winningValue = 120;
                int winnerSubscript = 0;
                for (int i = 0; i < 16; i++)
                {
                    if (scores[i] > 0)
                    {
                        if (scores[i] < winningValue)
                        {
                            winningValue = scores[i];
                            winnerSubscript = i;
                        }
                    }
                }

                if (winningValue != 120)
                {
                    winnerName = names[winnerSubscript];
                }
                else
                {
                    winnerName = "**NO WINNER**";
                }
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// This is called when the game should draw itself.
        /// </summary>
        /// <param name="gameTime">Provides a snapshot of timing values.</param>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            spriteBatch.Begin();

            if (pad1.IsConnected)
            {
                spriteBatch.DrawString(font, scores[0].ToString(), apos1, Color.Green);
                spriteBatch.DrawString(font, scores[1].ToString(), bpos1, Color.Red);
                spriteBatch.DrawString(font, scores[2].ToString(), xpos1, Color.Blue);
                spriteBatch.DrawString(font, scores[3].ToString(), ypos1, Color.Yellow);
            }

            if (pad2.IsConnected)
            {
                spriteBatch.DrawString(font, scores[4].ToString(), apos2, Color.Green);
                spriteBatch.DrawString(font, scores[5].ToString(), bpos2, Color.Red);
                spriteBatch.DrawString(font, scores[6].ToString(), xpos2, Color.Blue);
                spriteBatch.DrawString(font, scores[7].ToString(), ypos2, Color.Yellow);
            }

            if (pad3.IsConnected)
            {
                spriteBatch.DrawString(font, scores[8].ToString(), apos3, Color.Green);
                spriteBatch.DrawString(font, scores[9].ToString(), bpos3, Color.Red);
                spriteBatch.DrawString(font, scores[10].ToString(), xpos3, Color.Blue);
                spriteBatch.DrawString(font, scores[11].ToString(), ypos3, Color.Yellow);
            }

            if (pad4.IsConnected)
            {
                spriteBatch.DrawString(font, scores[12].ToString(), apos4, Color.Green);
                spriteBatch.DrawString(font, scores[13].ToString(), bpos4, Color.Red);
                spriteBatch.DrawString(font, scores[14].ToString(), xpos4, Color.Blue);
                spriteBatch.DrawString(font, scores[15].ToString(), ypos4, Color.Yellow);
            }

            spriteBatch.DrawString(font, winnerName, winnerPos, Color.White);

            spriteBatch.End();

            base.Draw(gameTime);
        }
    }
}
