﻿using System;

using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace SillyText
{
    interface ISillyText
    {
        void Draw(Microsoft.Xna.Framework.Graphics.SpriteBatch spriteBatch);
        SillyWord.FlyInStates FlyInState { get; set; }
        void StartFlyIn(int minTicks, int maxTicks);
        void StartFlyIn(int ticks);
        void StartFlyOut(int ticks);
        void StartFlyOut(int minTicks, int maxTicks);
        void StartTwizzle(float inTwizzleRotateLow, float inTwizzleRotateHigh, float inTwizzleRotateStep, float inTwizzleRorateSpeed);
        SillyWord.TwizzleStates TwizzleState { get; set; }
        bool IsMoving();
        void Update();
        SillyWord.WanderStates WanderState { get; set; }

        float X
        {
            get;
        }

        float Y
        {
            get;
        }

        float Width
        {
            get;
        }

        float Height
        {
            get;
        }

        float OffsetX
        {
            set;
            get;
        }

        float OffsetY
        {
            set;
            get;
        }

        float ShadowDistance
        {
            set;
        }
        float LightAngle
        {
            set;
        }
        Color TextColor
        {
            set;
        }
        Color SideColor
        {
            set;
        }
        Color ShadowColor
        {
            set;
        }
    }
}
